import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
import java.util.*;
import java.io.*;
import java.awt.*;
import java.awt.image.BufferedImage;
/**
 * Write a description of class wordl here.
 * @author Mathemagician
 */
public class wordl extends World
{
    Graphics2D g;
    double gravity = 0;
    boolean[][][] grid = new boolean[100][100][100];
    boolean day = true;
    float personX = 50.01f;
    float personY = 50.01f;
    float personZ = 50.01f;
    double rotationx = 0;
    double rotationy = 0;
    int sx,sy,sz;
    long time;
    boolean m = true;
    /**
     * Constructor for objects of class wordl.
     * 
     */
    public wordl()
    {    
        super(600, 400, 1); 
        BufferedImage image = getBackground().getAwtImage();
        g = image.createGraphics();
        for(int i=40;i<80;i++)
            for(int k=1;k<2;k++)
            for(int j=0;j<23;j++)
                {
                    grid[i][69+k][j+40] = true;
                }
        for(int i=0;i<4;i++)
            for(int j=0;j<4;j++)
                for(int k=65;k<70;k++){
                    grid[43+i*9][k][43+j*5] = true;
                    grid[44+i*9][k][43+j*5] = true;
                    grid[43+i*9][k][44+j*5] = true;
                    grid[44+i*9][k][44+j*5] = true;
                }
        draw();
    }
    public void act()
    {
        float a = time*.004f;
        if(Greenfoot.mouseMoved(this))
        {
            greenfoot.MouseInfo m = Greenfoot.getMouseInfo();
            rotationx = (m.getX()-300)*.02;
            rotationy = (m.getY()-200)*.02;
            draw();
        }
        if(Greenfoot.mouseClicked(this)){
            grid[sx][sy][sz] = false;
            draw();
        }
        if(Greenfoot.isKeyDown("w"))
            move(0,a);
        if(Greenfoot.isKeyDown("a"))
            move(1,a);
        if(Greenfoot.isKeyDown("d"))
            move(-1,a);
        if(Greenfoot.isKeyDown("s"))
            move(2,a);
        if(Greenfoot.isKeyDown("m")&&m){
            day = !day;
            draw();
            m = false;
        }
        else if(!Greenfoot.isKeyDown("m")) m = true;
        if(!grid[(int)personX][(int)personY+3][(int)personZ])
        {
            gravity+=a/6;
            personY+= gravity;
            draw();
        }
        else if(grid[(int)personX][(int)personY+2][(int)personZ])
        {
            gravity = 0;
            personY--;
            personY = (int)personY;
            draw();
        } else gravity = 0;
    }
    public void move(int dif,float a)
    {
            personZ+=a*Math.cos(rotationx-Math.PI*dif/2);
            personX+=a*Math.sin(rotationx-Math.PI*dif/2);
            if(grid[(int)(personX+1.5*Math.sin(rotationx-Math.PI*dif/2))+1][(int)personY][(int)(personZ+1.5*Math.cos(rotationx-Math.PI*dif/2))+1])
            {
                personZ-=a*Math.cos(rotationx-Math.PI*dif/2);
                personX-=a*Math.sin(rotationx-Math.PI*dif/2);
            }else draw();
    }
    public void draw()
    {
        time = System.currentTimeMillis();
        g.clearRect(0,0,600,400);
        if(day){
            g.setColor(Color.blue);
            g.fillRect(0,0,600,400);
        }
        Object[] blocks2 = getSorted();
        int polygons  = 0;
        Color yellow = new Color(150,100,150);
            int[][] order = {
                {0,1,3,2},
                {0,2,6,4},
                {0,4,5,1},
                {1,3,7,5},
                {2,3,7,6},
                {4,5,7,6}
            };
        for(int i=0;i<blocks2.length;i++)
        {
            Block b = (Block)blocks2[i];
            double rad= Math.atan2(b.z,b.x);
            double pow= Math.hypot(b.z,b.x);
            rad+=rotationx;
            float newx = (float)(pow*Math.cos(rad));
            float newz = (float)(pow*Math.sin(rad));
            rad = Math.atan2(newz,b.y);
            pow = Math.hypot(newz,b.y);
            rad+=rotationy;
            float newy = (float)(pow*Math.cos(rad));
            newz = (float)(pow*Math.sin(rad));
            double powStuff = Math.hypot(Math.hypot(b.y,b.z),b.x);
            if(newy<.4f&&newy>-.4f&&newx<.4f&&newx>-.4f)
            {
                sx = b.ix;
                sy = b.iy;
                sz = b.iz;
            }
            if(newz>.6f&&newy/newz<2f&&newy/newz>-2f&&newx/newz<3f&&newx/newz>-3f)
            {
                float[] xLoc = {b.x*100+50,b.x*100+50,b.x*100+50,b.x*100+50,b.x*100-50,b.x*100-50,b.x*100-50,b.x*100-50};
                float[] yLoc = {b.y*100+50,b.y*100+50,b.y*100-50,b.y*100-50,b.y*100+50,b.y*100+50,b.y*100-50,b.y*100-50};
                float[] zLoc = {b.z*100+50,b.z*100-50,b.z*100+50,b.z*100-50,b.z*100+50,b.z*100-50,b.z*100+50,b.z*100-50};
                for(int j=0;j<8;j++)
                {
                    rad = Math.atan2(zLoc[j],xLoc[j]);
                    pow = Math.hypot(zLoc[j],xLoc[j]);
                    rad+=rotationx;
                    xLoc[j] = (float)(pow*Math.cos(rad));
                    zLoc[j] = (float)(pow*Math.sin(rad));
                    rad = Math.atan2(zLoc[j],yLoc[j]);
                    pow = Math.hypot(zLoc[j],yLoc[j]);
                    rad+=rotationy;
                    yLoc[j] = (float)(pow*Math.cos(rad));
                    zLoc[j] = (float)(pow*Math.sin(rad));
                }
                int[] values = new int[3];
                if(b.x<-.5f&&!grid[b.ix+1][b.iy][b.iz])
                    values[0] = 0;
                else if(b.x>.5f&&!grid[b.ix-1][b.iy][b.iz])
                    values[0] = 5;
                else values[0] = 6;
                if(b.y<-.5f&&!grid[b.ix][b.iy+1][b.iz])
                    values[2] = 2;
                else if(b.y>.5f&&!grid[b.ix][b.iy-1][b.iz])
                    values[2] = 4;
                else values[2] = 6;
                if(b.z<-.5f&&!grid[b.ix][b.iy][b.iz+1])
                    values[1] = 1;
                else if(b.z > .5f&&!grid[b.ix][b.iy][b.iz-1])
                    values[1] = 3;
                else values[1] = 6;
                for(int j=0;j<3;j++)
                    if(values[j]<6)
                    {
                        int[] x = {300+(int)(300*xLoc[order[values[j]][0]]/zLoc[order[values[j]][0]]),300+(int)(300*xLoc[order[values[j]][1]]/zLoc[order[values[j]][1]]),
                            300+(int)(300*xLoc[order[values[j]][2]]/zLoc[order[values[j]][2]]),300+(int)(300*xLoc[order[values[j]][3]]/zLoc[order[values[j]][3]])};
                        int[] y = {200+(int)(300*yLoc[order[values[j]][0]]/zLoc[order[values[j]][0]]),200+(int)(300*yLoc[order[values[j]][1]]/zLoc[order[values[j]][1]]),
                            200+(int)(300*yLoc[order[values[j]][2]]/zLoc[order[values[j]][2]]),200+(int)(300*yLoc[order[values[j]][3]]/zLoc[order[values[j]][3]])};
                        if(ColorAt((x[0]+x[2])/2,(y[0]+y[2])/2))
                        {
                            if(day)
                                g.setColor(yellow);
                            else g.setColor(new Color((int)(127/powStuff),(int)(127/powStuff),(int)(127/powStuff)));
                            if(newy<.3f&&newy>-.3f&&newx<.3f&&newx>-.3f)
                               g.setColor(Color.red);
                            g.fillPolygon(x,y,4);
                            g.setColor(Color.black);
                            g.drawPolygon(x,y,4);
                            polygons++;
                        }
                    }
            }
        }
        time = System.currentTimeMillis()-time;
        getBackground().setColor(Color.red);
        getBackground().drawString("+",300,200);
        getBackground().drawString(""+time,100,100);
    }
    public Object[] getSorted()
    {
        java.util.List<Block> blocks = new ArrayList<Block>();
        for(int i=0;i<100;i++)
            for(int j=0;j<100;j++)
                for(int k=0;k<100;k++)
                    if(grid[i][j][k])
                        if(!grid[i+1][j][k]||!grid[i-1][j][k]||!grid[i][j+1][k]||!grid[i][j-1][k]||!grid[i][j][k+1]||!grid[i][j][k-1])
                            if(Math.hypot(Math.hypot(i-personX,j-personY),k-personZ)<15||day){
                                    double rad = Math.atan2(k-personZ,i-personX);
                                    double pow = Math.hypot(k-personZ,i-personX);
                                    rad+=rotationx;
                                    float newx = (float)(pow*Math.cos(rad));
                                    float newz = (float)(pow*Math.sin(rad));
                                    rad = Math.atan2(newz,j-personY);
                                    pow = Math.hypot(newz,j-personY);
                                    rad+=rotationy;
                                    float newy = (float)(pow*Math.cos(rad));
                                    newz = (float)(pow*Math.sin(rad));
                                    if(newz>.6f&&newy/newz<2f&&newy/newz>-2f&&newx/newz<3f&&newx/newz>-3f){
                                        blocks.add(new Block(i-personX,j-personY,k-personZ,i,j,k));
                                    }
                            }
        Object[] blocks2 = blocks.toArray();
        Arrays.sort(blocks2);
        return blocks2;
    }
    public boolean ColorAt(int x,int y)
    {
        if(x>859)
            return false;
        else if(x<-270)return false;
        else if(y>799)
            return false;
        else if(y<-270)return false;
        else return true;
    }
    public class Block implements Comparable
    {
        float x;
        float y;
        float z;
        float dif;
        int ix;
        int iz;
        int iy;
        public Block(float x,float y,float z,int ix,int iy,int iz)
        {
            this.x = x;
            this.y = y;
            this.z = z;
            this.iz = iz;
            this.iy = iy;
            this.ix = ix;
            dif = x*y*z;
            if(dif<0)dif = -dif;
        }
        public int compareTo(Object other)
        {
            Block b = (Block)other;
            if(b.dif>dif)
                return 1;
            else if(b.dif<dif)
                return -1;
            else return 0;
        }
    }
}
